    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025     * Other names may be trademarks of their respective owners.]
    026     *
    027     * --------------------
    028     * ShadowGenerator.java
    029     * --------------------
    030     * (C) Copyright 2009, 2011, by Object Refinery Limited and Contributors.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 10-Jul-2009 : Version 1 (DG);
    038     *
    039     */
    040
    041    package org.jfree.chart.util;
    042
    043    import java.awt.image.BufferedImage;
    044
    045    /**
    046     * An interface that defines the API for a shadow generator.  Some plot
    047     * classes use this to create drop shadows.
    048     *
    049     * @since 1.0.14
    050     */
    051    public interface ShadowGenerator {
    052
    053        /**
    054         * Creates and returns an image containing the drop shadow for the
    055         * specified source image.
    056         *
    057         * @param source  the source image.
    058         *
    059         * @return A new image containing the shadow.
    060         */
    061        public BufferedImage createDropShadow(BufferedImage source);
    062
    063        /**
    064         * Calculates the x-offset for drawing the shadow image relative to the
    065         * source.
    066         *
    067         * @return The x-offset.
    068         */
    069        public int calculateOffsetX();
    070
    071        /**
    072         * Calculates the y-offset for drawing the shadow image relative to the
    073         * source.
    074         *
    075         * @return The y-offset.
    076         */
    077        public int calculateOffsetY();
    078
    079    }